const fs = require('fs');
const path = require('path');
const chalk = require('chalk');

// todo: 把这个替换掉
require("@babel/register")({
    presets: [require.resolve("@babel/preset-env")]
});

/**
 * 检查组件配置文件
 * @param {*} folder 
 */
module.exports.checkComponentFiles = function checkConfigs(folder) {

    if (!fs.existsSync(path.join(folder))) {
        console.error(chalk.red(`cannot found folder ${folder}.`));
        process.exit()
    }

    {
        const oldConfigs = ['js/config.js', 'mocks/data.js'];
        const exists = oldConfigs.every(file => fs.existsSync(path.join(folder, file)));
        if (exists) {
            // 垫一下变量名防止js访问变量空指针
            global.window = {
                appConfig: {},
                ASSETS_URL: ''
            };
            const base = require(path.resolve(folder, 'js/config.js')).config.base;
            return { base }
        }
    }

    const newConfigs = ['config/main.json', 'config/main.data.json'];
    newConfigs.every(file => {
        if (!fs.existsSync(path.join(folder, file))) {
            console.error(chalk.red(`${file} cannot be found in folder ${folder}, if the folder is not a component folder please move it out.`));
            process.exit()
        }
        return true
    })

    return {
        base: JSON.parse(fs.readFileSync(path.join(folder, newConfigs[0]))).base,
    }
}