const fs = require('fs');
const path = require('path');
const commonConfig = require('./webpack.config.common');

const { appComponents, appBuild, webpackConfigExtend } = require('./paths');

let webpackConfigExtendFn;
if (fs.existsSync(webpackConfigExtend)) {
  webpackConfigExtendFn = require(webpackConfigExtend);
}

process.env.NODE_ENV = 'production';

module.exports = ({ filename, module_name, version }, { uniqueId }) => {
  const entry = path.resolve(appComponents, filename, 'index')
  const cf = {
    ...commonConfig({ isProduction: true, uniqueId, entrys: [entry] }),
    mode: process.env.NODE_ENV,
    entry,
    output: {
      path: appBuild,
      filename: `${filename}.${version}.js`,
      library: `${module_name}@${version}`,
      libraryTarget: 'amd',
    },
    externals: ['react', 'react-dom', 'three', 'lodash', 'd3', '@material-ui/styles'],
    devtool: false,
  }

  if (webpackConfigExtendFn) {
    return webpackConfigExtendFn(cf, {
      production: true
    })
  }
  return cf;
};
